* PACKAGE DEULER    !" ʬ( Euler Scheme )
*
*"  [HIS] 92/01/13 (momoko)
*"        95/08/14 (takepiro) 
*"        98/06/10 (takepiro) Ǥβٷ׻
*         98/09/09 (takepiro) bsnsq_2d  ddbsn_2d ذܿ
***********************************************************************
      SUBROUTINE DEULER
     O             ( PSI3  , ZETA3 , T3   , C3 , 
     I               PSI2  , ZETA2 , T2   , C2 , 
     I               RAYL  , PRND  , QINT,
     I               RAYLC , PRNDC , QINTC,
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2         )
*
*"      << Euler scheme ˤ꼡ƥåפʪ̤׻ >>
*"                     92/01/13 ()
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL C3    ( 0:NX+1 , 0:NZ+1 ) !" ǻ(STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL C2    ( 0:NX+1 , 0:NZ+1 ) !" ǻ(1STEP)
*
      REAL PRND                 !" ץȥ
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
      REAL PRNDC                !" ץȥ
      REAL RAYLC                !" 쥤꡼
      REAL QINTC                !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP2 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DEULER',
     &               'EULER SCHEME TIME INTEGRATE : 98/09/09' )
      ENDIF
*
*"        < 1. ΰα٤η׻ >
*
      CALL DEULRZ
     O       ( ZETA3 , 
     I         PSI2  , ZETA2 , T2  , C2 , 
     C         RAYL  , PRND  , RAYLC,
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 2. ΰβ٤η׻ >
*
      CALL DEULRT
     O       ( T3    , 
     I         PSI2  , T2  , 
     C         QINT  , 
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 3. ΰǻ٤η׻ >
*
      CALL DEULRC
     O       ( C3    , 
     I         PSI2  , C2    , 
     C         PRNDC , QINTC , 
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 4. ŬѤήؿη׻ >
*
      CALL DBNDR
     O       ( PSI3 , 
     M         ZETA3, T3  , C3 , 
     I         DX   , DZ   )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DEULRZ          !" Euler scheme ˤ뱲
     O             ( ZETA3 , 
     I               PSI2  , ZETA2 , T2   , C2 , 
     C               RAYL  , PRND  , RAYLC,  
     C               DX    , DZ    , DT   ,
     W               AJAC2 , ALAP2   )
*
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !"(STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !"ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
      REAL C2    ( 0:NX+1 , 0:NZ+1 ) !"ǻ(1STEP)
*
      REAL PRND                      !"ץȥ
      REAL RAYL                      !"쥤꡼
      REAL RAYLC                     !"쥤꡼
*
      REAL DX                        !"Xγʻֳ
      REAL DZ                        !"Zγʻֳ
      REAL DT                        !"ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP2 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ!
      INTEGER IZ                   !"롼ץ
*
*"        < 1. ٤λѲη׻ >
*
      CALL DEULTZ
     O       ( ZETA3 , 
     I         PSI2  , ZETA2 , T2    , C2 , 
     C         RAYL  , PRND  , RAYLC ,
     C         DX    , DZ    , 
     W         AJAC2 , ALAP2   )
*
*"        < 2. ƥåɤα٤ͤη׻ >
*
      DO 3020 IZ = 1 , NZ
        DO 3010 IX = 1 , NX
              ZETA3( IX,IZ ) 
     &    =   ZETA2( IX,IZ ) + DT * ZETA3( IX, IZ )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
**********************************************************************
      SUBROUTINE DEULTZ          !" Euler scheme ˤ뱲٤λѲ
     O             ( TNDZ, 
     I               PSI   , ZETA  , T     , C , 
     C               RAYL  , PRND  , RAYLC ,
     C               DX    , DZ    , 
     W               AJAC  , ALAP    )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDZ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA  ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL C     ( 0:NX+1 , 0:NZ+1 ) !" ǻ(1STEP)
*
      REAL PRND                      !" ץȥ
      REAL RAYL                      !" 쥤꡼
      REAL RAYLC                     !"쥤꡼
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
* [WORK]
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ!
      INTEGER IZ                   !"롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , ZETA ,
     C         DX   , DZ    )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         ZETA ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤα٤λѲη׻ >
*
      DO 3020 IZ = 1 , NZ
        DO 3010 IX = 1 , NX
               TNDZ( IX,IZ ) 
     &     =   AJAC(IX,IZ) + PRND * ALAP(IX,IZ)
     &       - PRND*RAYL*( T(IX+1,IZ)-T(IX-1,IZ) )/(2.*DX) 
     &       - PRND*RAYLC*( C(IX+1,IZ)-C(IX-1,IZ) )/(2.*DX) 
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULRT                !" Euler scheme ˤ벹
     O             ( T3    , 
     I               PSI2  , T2  , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2 ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T2   ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1,0:NZ+1 ) !" 䥳ӥ
      REAL ALAP2 ( 0:NX+1,0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. ٤λѲη׻ >
*
      CALL DEULTT
     O         ( T3    , 
     I           PSI2  , T2  , 
     C           QINT  , 
     C           DX    , DZ  , 
     W           AJAC2 , ALAP2   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3010 IZ = 0 , NZ+1
         DO 3020 IX = 1 , NX
              T3(IX,IZ)
     &    =   T2(IX,IZ) + DT * T3( IX, IZ )
 3020    CONTINUE
 3010 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULTT        !" Euler scheme ˤ벹٤λѲ
     O             ( TNDT  , 
     I               PSI   , T    , 
     C               QINT  , 
     C               DX    , DZ   ,
     W               AJAC  , ALAP  )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDT  ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
*  [WORK]
      REAL AJAC  ( 0:NX+1,0:NZ+1 )   !" 䥳ӥ
      REAL ALAP  ( 0:NX+1,0:NZ+1 )   !" ץ饷
*
      REAL       TFB(NX)             !" üβ/ٷ
      REAL       TFT(NX)             !" üβ/ٷ
*
      LOGICAL    OTFIXB              !" üǮ凉å
      LOGICAL    OTFIXT              !" üǮ凉å
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , T   ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         T    ,
     C         DX   , DZ   )
*
*"        < 3. Ǥη׻ (ǥեåͿ) >
*
      CALL DBNDRT
     O     ( TFB    , TFT   ,
     O       OTFIXB , OTFIXT  )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      IF ( .NOT. OTFIXB ) THEN
         DO 1010 IX = 1, NX
            ALAP( IX, 0 ) 
     &    = ( T(IX+1,0) - 2*T(IX,0) + T(IX-1,0) )/DX**2
     &      + (  ( T(IX,1)-T(IX,0) )/DZ - TFB(IX) )/DZ
 1010    CONTINUE
*
         DO 1020 IX = 1, NX
           TNDT(IX,0)
     &          =  AJAC(IX,0) + ALAP(IX,0) + 0.5 * QINT
 1020    CONTINUE
      ENDIF
*
      DO 2010 IZ = 1 , NZ
         DO 2020 IX = 1 , NX
           TNDT(IX,IZ)
     &          =  AJAC(IX,IZ) + ALAP(IX,IZ) + QINT 
 2020   CONTINUE
 2010 CONTINUE
*
      IF ( .NOT. OTFIXT ) THEN
         DO 3010 IX = 1, NX
            ALAP( IX, NZ+1 ) 
     &    = ( T(IX+1,NZ+1) - 2*T(IX,NZ+1) + T(IX-1,NZ+1) )/DX**2
     &      + ( TFT(IX) - ( T(IX,NZ+1)-T(IX,NZ) )/DZ  )/DZ
 3010    CONTINUE
*
         DO 3020 IX = 1, NX
           TNDT(IX,NZ+1)
     &          =  AJAC(IX,NZ+1) + ALAP(IX,NZ+1) + 0.5 * QINT 
 3020    CONTINUE
      ENDIF
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULRC                !" Euler scheme ˤǻ
     O             ( C3    , 
     I               PSI2  , C2    , 
     C               PRNDC , QINTC , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL C3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2 ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL C2   ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRNDC                     !" ץȥ
      REAL QINTC                     !" ȯΨ
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1,0:NZ+1 ) !" 䥳ӥ
      REAL ALAP2 ( 0:NX+1,0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. ǻ٤λѲη׻ >
*
      CALL DEULTC
     O         ( C3    , 
     I           PSI2  , C2    , 
     C           PRNDC , QINTC , 
     C           DX    , DZ    , 
     W           AJAC2 , ALAP2   )
*
*"        < 3. ƥåɤǻ٤ͤη׻ >
*
      DO 3010 IZ = 0 , NZ+1
         DO 3020 IX = 1 , NX
              C3(IX,IZ)
     &    =   C2(IX,IZ) + DT * C3( IX, IZ )
 3020    CONTINUE
 3010 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULTC        !" Euler scheme ˤǻ٤λѲ
     O             ( TNDC  , 
     I               PSI   , C    , 
     C               PRNDC , QINTC, 
     C               DX    , DZ   ,
     W               AJAC  , ALAP  )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDC  ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL C     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRNDC                     !" ץȥ
      REAL QINTC                     !" ȯΨ
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
*  [WORK]
      REAL AJAC  ( 0:NX+1,0:NZ+1 )   !" 䥳ӥ
      REAL ALAP  ( 0:NX+1,0:NZ+1 )   !" ץ饷
*
      REAL       CFB(NX)             !" üβ/ٷ
      REAL       CFT(NX)             !" üβ/ٷ
*
      LOGICAL    OCFIXB              !" üǮ凉å
      LOGICAL    OCFIXT              !" üǮ凉å
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , C   ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         C    ,
     C         DX   , DZ   )
*
*"        < 3. Ǥη׻ (ǥեåͿ) >
*
      CALL DBNDRC
     O     ( CFB    , CFT   ,
     O       OCFIXB , OCFIXT  )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      IF ( .NOT. OCFIXB ) THEN
         DO 1010 IX = 1, NX
            ALAP( IX, 0 ) 
     &    = ( C(IX+1,0) - 2*C(IX,0) + C(IX-1,0) )/DX**2
     &      + (  ( C(IX,1)-C(IX,0) )/DZ - CFB(IX) )/DZ
 1010    CONTINUE
*
         DO 1020 IX = 1, NX
           TNDC(IX,0)
     &          =  AJAC(IX,0) + PRNDC*ALAP(IX,0) + 0.5 * QINTC
 1020    CONTINUE
      ENDIF
*
      DO 2010 IZ = 1 , NZ
         DO 2020 IX = 1 , NX
           TNDC(IX,IZ)
     &          =  AJAC(IX,IZ) + PRNDC*ALAP(IX,IZ) + QINTC
 2020   CONTINUE
 2010 CONTINUE
*
      IF ( .NOT. OCFIXT ) THEN
         DO 3010 IX = 1, NX
            ALAP( IX, NZ+1 ) 
     &    = ( C(IX+1,NZ+1) - 2*C(IX,NZ+1) + C(IX-1,NZ+1) )/DX**2
     &      + ( CFT(IX) - ( C(IX,NZ+1)-C(IX,NZ) )/DZ  )/DZ
 3010    CONTINUE
*
         DO 3020 IX = 1, NX
           TNDC(IX,NZ+1)
     &          =  AJAC(IX,NZ+1) + PRNDC*ALAP(IX,NZ+1) + 0.5 * QINTC
 3020    CONTINUE
      ENDIF
*
      RETURN
      END
